#pragma once
#include "stdafx.h"
#include "InstanceData.h"
#include "StatisticsCollection.h"

int FindEarliestSlotNaive(JobInfo *jobInfo, int startTime)
{
	while (true)
	{
		int endTime = startTime + jobInfo->duration - 1;
		for (int slot = startTime; slot <= endTime; slot++)
			for (int *resource = jobInfo->consumedResources, *volume = jobInfo->consumedVolumes; *resource >= 0; resource++, volume++)
				if (resourceAvailability[*resource][slot] < *volume)
				{
					startTime = slot + 1;
					goto continueSearch;
				}

		return startTime;

	continueSearch:;
	}
}


int FindEarliestSlotTestManyResources(JobInfo *jobInfo, int startTime)
{
	int earliestSlotToCheck = startTime;
	while (true)
	{
		int endTime = startTime + jobInfo->duration - 1;

		for (int slot = endTime; slot >= earliestSlotToCheck; slot--)
		{
			slotsTested++;
			for (int *resource = jobInfo->consumedResources, *volume = jobInfo->consumedVolumes; *resource >= 0; resource++, volume++)
				if (resourceAvailability[*resource][slot] < *volume)
				{
					startTime = slot + 1;
					earliestSlotToCheck = endTime + 1;
					restarts++;
					goto continueSearch;
				}
		}

		return startTime;

	continueSearch:;
	}
}

int FindEarliestSlotTestSingleResource(JobInfo *jobInfo, int startTime)
{
	int resource = *jobInfo->consumedResources;
	int consumption = *jobInfo->consumedVolumes;
	int* availability = resourceAvailability[resource];

	int earliestSlotToCheck = startTime;
	while (true)
	{
		int endTime = startTime + jobInfo->duration - 1;

		for (int slot = endTime; slot >= earliestSlotToCheck; slot--)
		{
			slotsTested++;
			if (availability[slot] < consumption)
			{
				startTime = slot + 1;
				earliestSlotToCheck = endTime + 1;
				restarts++;
				goto continueSearch;
			}
		}

		return startTime;

	continueSearch:;
	}
}


void UpdateResourseAvailabilityMany(JobInfo *jobInfo, int startTime)
{
	int endTime = startTime + jobInfo->duration - 1;

	for (int *resource = jobInfo->consumedResources, *volume = jobInfo->consumedVolumes; *resource >= 0; resource++, volume++)
	{
		int *curResourceAvailability = resourceAvailability[*resource];
		for (int slot = startTime; slot <= endTime; slot++)
			curResourceAvailability[slot] -= *volume;
	}
}

void UpdateResourseAvailabilitySingle(JobInfo *jobInfo, int startTime)
{
	int resource = *jobInfo->consumedResources;
	int consumption = *jobInfo->consumedVolumes;

	int *curResourceAvailability = resourceAvailability[resource];
	for (int slot = startTime + jobInfo->duration - 1; slot >= startTime; slot--)
		curResourceAvailability[slot] -= consumption;
}
