#include "AlgorithmParameters.h"
#include <cstdio>
#include <climits>
int *maxCounters;

void LoadDefault()
{
	for (int i = 0; i < MaxTuningExecutions; i++)
		maxCounters[i] = i / 2 - 5;
}

void LoadConfidenceCounters()
{
	maxCounters = new int[MaxTuningExecutions];
	FILE *f = fopen(SignTestFilename, "r");
	if (!f)
	{
		printf("Failed to open '%s'.  Using default confidence counters (not based on sign tests).\n", SignTestFilename);
		LoadDefault();
	}
	else
	{
		for (int i = 0; i < MaxTuningExecutions - 1; i++)
			if (fscanf(f, "%d", maxCounters + i) == EOF)
			{
				LoadDefault();
				break;
			}
		fclose(f);

		// If the decision is not made after MaxTuningExecutions, then the implementation that "won" more often is chosen
		maxCounters[MaxTuningExecutions - 1] = INT_MAX; 
	}
}

int GetMaxCounterForConfidence(int numberOfExecutions)
{
	return maxCounters[numberOfExecutions];
}
